"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DEFAULT_ORDER_FLAG: () => DEFAULT_ORDER_FLAG,
  EIP712_DOMAIN: () => EIP712_DOMAIN,
  ProductType: () => ProductType,
  buildAccountId: () => buildAccountId,
  encodeFlag: () => encodeFlag
});
module.exports = __toCommonJS(src_exports);
var ProductType = /* @__PURE__ */ ((ProductType2) => {
  ProductType2[ProductType2["Unknown"] = 0] = "Unknown";
  ProductType2[ProductType2["Perpetual"] = 1] = "Perpetual";
  ProductType2[ProductType2["Spot"] = 2] = "Spot";
  return ProductType2;
})(ProductType || {});
var buildAccountId = (address, productType, brokerId, subaccountIndex) => {
  return `${address}${`${brokerId}`.padStart(8, "0")}0000${`${productType}`.padStart(8, "0")}${`${subaccountIndex}`.padStart(4, "0")}`;
};
var TIME_IN_FORCES = [
  "default",
  "immediate_or_cancel",
  "fill_or_kill",
  "post_only"
];
var SELF_TRADE_BEHAVIORS = [
  // cancel the maker order and continue to fill taker
  "cancel_provide",
  // cancel the remaining of the taker, stop filling
  "decrease_take",
  // abort the fill process, revert all filled and force cancel the maker order
  "expire_both",
  // allow self trade
  "fill"
];
var DEFAULT_ORDER_FLAG = {
  expiresAt: void 0,
  reduceOnly: false,
  timeInForce: "default",
  isMarketOrder: false,
  selfTradeBehavior: "cancel_provide"
};
var encodeFlag = (flag) => {
  const isMarket = flag.isMarketOrder ? 1n : 0n;
  const reduceOnly = flag.reduceOnly ? 1n : 0n;
  const tif = BigInt(TIME_IN_FORCES.indexOf(flag.timeInForce));
  const stb = BigInt(SELF_TRADE_BEHAVIORS.indexOf(flag.selfTradeBehavior));
  return tif << 62n | reduceOnly << 61n | isMarket << 60n | stb << 58n | BigInt(flag.expiresAt || 0);
};
var EIP712_DOMAIN = {
  name: "FOUNDATION",
  chainId: 1,
  version: "0.1.0"
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DEFAULT_ORDER_FLAG,
  EIP712_DOMAIN,
  ProductType,
  buildAccountId,
  encodeFlag
});
